package cn.edu.xidian.graduation.modelchecking.model;

import java.util.Set;

/**
 * An abstract state is obtained by a abstraction function which performs the
 * abstraction by selecting a set of variables which are insensitive to the
 * desired property to be invisible
 * 
 * @author wenqiang.fanwq
 * @see Conterexample
 */
public class AbstractState extends BaseState {
	private long weight;

	public AbstractState(long id) {
		super(id);
	}

	private Set<OriginalState> data;

	@Override
	public Set<OriginalState> getData() {
		return data;
	}

	@Override
	public void setData(Object data) {
		this.data = (Set<OriginalState>) data;
	}

	public long getWeight() {
		return weight;
	}

	public void setWeight(long weight) {
		this.weight = weight;
	}

	@Override
	public String toString() {
		return "AbstractState [id=" + getId() + ",data=" + dataString()
				+ (getInfo() != null ? (",info=" + getInfo()) : "") + "]";
	}

	@Override
	public String simpleToString() {
		StringBuilder sb = new StringBuilder();
		sb.append("\"#");
		sb.append(getId());
		if (data != null && data.size() > 0) {
			sb.append("[");
			for (OriginalState s : data) {
				sb.append(s.getId());
				sb.append(",");
			}
			sb.deleteCharAt(sb.length() - 1);
			sb.append("]");
		}
		sb.append("\"");

		return sb.toString();
	}

	private String dataString() {
		StringBuilder sb = new StringBuilder();
		sb.append("[");
		for (OriginalState s : data) {
			sb.append(s.getId());
			sb.append(",");
		}
		sb.replace(sb.length() - 1, sb.length(), "]");
		return sb.toString();
	}

}
