package cn.edu.xidian.graduation.modelchecking.model;

/**
 * A abstract implementation of State
 * 
 * @author wenqiang.fanwq
 * 
 */
public abstract class BaseState implements State {
	/**
	 * the identifier of this state.if two states have the same id value, they
	 * are equal
	 */
	private long id;

	/** other info to this state */
	private Object info;

	public BaseState(long id) {
		this.id = id;
	}

	@Override
	public long getId() {
		return id;
	}

	@Override
	public Object getInfo() {
		return info;
	}

	@Override
	public void setInfo(Object info) {
		this.info = info;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (id ^ (id >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		State other = (State) obj;
		if (id == other.getId())
			return true;
		return false;
	}

}
